#!/usr/bin/perl 

use Getopt::Std;

%option = ();
getopts("d:p:i:c:o:f:u:",\%option);

if( (!$option{p}) || (!$option{f}) || (!$option{c}) || (!$option{i}) || (!$option{d}) || (!$option{o}) ){
  print "Usage:\n";
  print "getClusters.pl -c <full categories file> -d <cluster file> -p <cluster paths file>  -o <cluster output file>  -i <isolated paths file> -f <isolated paths output file> -u <isWeighted>\n";
  exit(1);
}


open(CATEGORIES,$option{c}) || die "couldn't open $option{c}\n";
$categoryNumber=1;
while(<CATEGORIES>){
  chomp;
  s/\s+//g;
  $categories{$categoryNumber}=$_;
  $categoryNumber++;
}
close(CATEGORIES);


open(POINTS,$option{i}) || die "couldn't open $option{i}\n";
open(OFILE,">$option{f}") || die "couldn't open $option{f}\n";
if($option{u} == 0){
  while(<POINTS>){
    chomp;
    @path = split;
    foreach $entry (@path){
      print OFILE "$categories{$entry} ";
    }
    print OFILE "\n";  
  }
}
else{
  while(<POINTS>){
    chomp;
    @path = split;
    $isCategory=1;
    foreach $entry (@path){
      if($isCategory == 1){
	print OFILE "$categories{$entry} ";
	$isCategory=0;
      }
      else {
	print OFILE "$entry ";
	$isCategory=1;
      }
    }
    print OFILE "\n";  
  }
}
close(OFILE);
close(POINTS);

open(DATA,$option{d}) || die "couldn't open $option{d}\n";
open(PATHS,$option{p}) || die "couldn't open $option{p}\n";
open(OUT,">$option{o}") || die "couldn't open $option{o}\n";
open(RAW,">$option{o}.raw") || die "couldn't open $option{o}.raw\n";

if($option{u} == 0){
  while(<DATA>){
    chomp;  
    print OUT "$_ ";
    print RAW "$_ ";
    
    $line=<PATHS>;
    chomp $line;
    @path=split / /,$line;
    foreach $entry (@path){
	print OUT "$categories{$entry} ";
	print RAW "$entry ";
      }
    print OUT "\n";  
    print RAW "\n";  
  }
}
else{
  while(<DATA>){
    chomp;  
    print OUT "$_ ";
    print RAW "$_ ";
    
    $line=<PATHS>;
    chomp $line;
    @path=split / /,$line;
    $isCategory=1;
    foreach $entry (@path){
      if($isCategory == 1){
	print OUT "$categories{$entry} ";
	print RAW "$entry ";
	$isCategory=0;
      }
      else {
	print OUT "$entry ";
	print RAW "$entry ";
	$isCategory=1;
      }
    }
    print OUT "\n";  
    print RAW "\n";  
  }
}
close(PATHS);
close(DATA);
close(OUT);
close(RAW);


