#!/usr/bin/perl 

use Getopt::Std;

%option = ();
getopts("d:o:",\%option);

if( (!$option{d}) || (!$option{o}) ){
  print "Usage:\n";
  print "giveResults.pl -d <intermediate result file> -o <cluster result file>\n";
  exit(1);
}

open(IN,"$option{d}") || die "couldn't open file $option{d} : $!\n";
open(OUT,">$option{o}") || die "couldn't open file $option{o} : $!\n";

%cluster = ();

while(<IN>){
  chomp;
  ($clusterid,@path)=split;
  push @{ $cluster{$clusterid} }, "path : @path\n"; 
}
close(IN);

foreach $clusterid ( sort { $a <=> $b } keys %cluster ){
  print OUT "CLUSTER $clusterid :\n-----------\n @{ $cluster{$clusterid} }\n";
}
close(OUT);


