#!/usr/bin/perl 

use Getopt::Std;

%option = ();
getopts("p:s:u:o:",\%option);

if( (!$option{p}) || (!$option{s}) || (!$option{u}) || (!$option{o}) ){
  print "Usage:\n";
  print "splinput.sulekha.pl -p <paths file> -s <separate points file> -u <unique paths file> -o <clustered paths file>\n";
  exit(1);
}

%points = ();
open(POINTS,$option{s}) || die "couldn't open $option{s}\n";
while(<POINTS>){
  chomp;
  $points{$_} = 1;
}
close(POINTS);

open(PATHS,$option{p}) || die "couldn't open $option{p}\n";
open(UNIQUE,">$option{u}") || die "couldn't open $option{u}\n";
open(OUT,">$option{o}") || die "couldn't open $option{o}\n";

$linenumber = 1;
while(<PATHS>){
  chomp;  
  if(defined($points{$linenumber})){
    print UNIQUE "$_\n";
  }
  else{
    print OUT "$_\n";
  }
  $linenumber++;
}
close(PATHS);
close(UNIQUE);
close(OUT);
